package pfc;

import java.util.*;

import javax.faces.model.*;
import javax.faces.bean.ManagedProperty;
import javax.faces.context.FacesContext;

import com.sun.faces.context.ApplicationMap;




public class Controller {
	private DataManager dataManager;
	
	private String selectedDevice;
	private String selectedFileType;
	private List<SelectItem> deviceItems;
	private List<SelectItem> fileTypeItems;
	
	private Device device;
	private List<File> otherFiles;
	private List<AudioFile> audioFiles;
	private List<VideoFile> videoFiles;
	private List<ImageFile> imageFiles;
	private List<ExecutableFile> executableFiles;
	
	private boolean showResults;
	private boolean filterON;
	
	Set<SelectItem> osItems;
	
	
	private Filter filter = new Filter();
	
	public Controller()
	{
		
 	
		dataManager = new DataManager();
		deviceItems = new ArrayList<SelectItem>();
		deviceItems.add(new SelectItem("0", "Seleccionar dispositiu ..."));
		Iterator<String> it = dataManager.getDeviceNames().iterator();
		int i=1;
		while ( it.hasNext() ) {
			deviceItems.add(new SelectItem(Integer.toString(i), it.next()));
			i++;
		}
		
		
		fileTypeItems = new ArrayList<SelectItem>();
		fileTypeItems.add(new SelectItem("0", "Tots"));
		fileTypeItems.add(new SelectItem("1", "Audio"));
		fileTypeItems.add(new SelectItem("2", "Video"));
		fileTypeItems.add(new SelectItem("3", "Imatge"));
		fileTypeItems.add(new SelectItem("4", "Altres"));
		
		
		selectedDevice="0";
		selectedFileType = "0";
		
		
		audioFiles = new ArrayList<AudioFile>();
		videoFiles = new ArrayList<VideoFile>();
		imageFiles = new ArrayList<ImageFile>();
		executableFiles = new ArrayList<ExecutableFile>();
		otherFiles = new ArrayList<File>();
		
		showResults = false;
		filterON = false;
	}
	
	
	public boolean isFilterON() {
		return filterON;
	}


	public void setFilterON(boolean filterON) {
		this.filterON = filterON;
	}


	public Set<SelectItem> getOsItems() {
		return osItems;
	}


	public void setOsItems(Set<SelectItem> osItems) {
		this.osItems = osItems;
	}


	public List<SelectItem> getDeviceItems() {
		return deviceItems;
	}

	public void setDeviceItems(List<SelectItem> deviceItems) {
		this.deviceItems = deviceItems;
	}

	public List<SelectItem> getFileTypeItems() {
		return fileTypeItems;
	}

	public void setFileTypeItems(List<SelectItem> fileTypeItems) {
		this.fileTypeItems = fileTypeItems;
	}
	
	public Device getDevice() {
		return device;
	}

	public void setDevice(Device device) {
		this.device = device;
	}
	
	public String getSelectedDevice(){
		return selectedDevice;
	}
	
	public void setSelectedDevice(String device) {
		selectedDevice = device;
	}
	
	public String getSelectedFileType() {
		return selectedFileType;
	}
	
	public void setSelectedFileType(String fileType) {
		selectedFileType = fileType;
	}
	
	
	public List<File> getOtherFiles() {
		return otherFiles;
	}


	public void setOtherFiles(List<File> otherFiles) {
		this.otherFiles = otherFiles;
	}


	public List<AudioFile> getAudioFiles() {
		return audioFiles;
	}


	public void setAudioFiles(List<AudioFile> audioFiles) {
		this.audioFiles = audioFiles;
	}


	public List<VideoFile> getVideoFiles() {
		return videoFiles;
	}


	public void setVideoFiles(List<VideoFile> videoFiles) {
		this.videoFiles = videoFiles;
	}


	public List<ImageFile> getImageFiles() {
		return imageFiles;
	}


	public void setImageFiles(List<ImageFile> imageFiles) {
		this.imageFiles = imageFiles;
	}


	public List<ExecutableFile> getExecutableFiles() {
		return executableFiles;
	}


	public void setExecutableFiles(List<ExecutableFile> executableFiles) {
		this.executableFiles = executableFiles;
	}


	public boolean isShowResults() {
		return showResults;
	}


	public void setShowResults(boolean showResults) {
		this.showResults = showResults;
	}


	public Filter getFilter() {
		return filter;
	}


	public void setFilter(Filter filter) {
		this.filter = filter;
	}


	public String applyFilter() {
		deviceItems.clear();
		deviceItems.add(new SelectItem("0", "Seleccionar dispositiu ..."));
		
	
		Set<String> filteredSet = dataManager.getDeviceNames(); 
		
		if (filter.isAccelActive()) {
			Set<String> devsWithAccel = dataManager.getDeviceNamesWithAccelerometer();
			if (filter.isAccel()) {
				filteredSet = devsWithAccel;
			} else {
				filteredSet.removeAll(devsWithAccel);
			}
		}
		
		if (filter.isLightActive()) {
			Set<String> devsWithLight = dataManager.getDeviceNamesWithLightSensor();
			if (filter.isLight()) {
				filteredSet.retainAll(devsWithLight);
			} else {
				filteredSet.removeAll(devsWithLight);
			}
		}
		
		if (filter.isHtml5Active()) {
			Set<String> devsWithHTML5 = dataManager.getDeviceNamesWithHTML5Support(); 
			if (filter.isHtml5()) {
				filteredSet.retainAll(devsWithHTML5);
			} else {
				filteredSet.removeAll(devsWithHTML5);
			}
		}

		if (filter.isFlashActive()) {
			filteredSet.retainAll(dataManager.getDeviceNamesWithFlash(filter.isFlash()));
		}
		
		if (filter.isSatActive()) {
			Set<String> devsWithSat = dataManager.getDeviceNamesWithSatelliteLocation();
			if (filter.isSat()) {
				filteredSet.retainAll(devsWithSat);
			} else {
				filteredSet.removeAll(devsWithSat);
			}
		}
		
		if (filter.isWifiActive()) {
			Set<String> devsWithWifi = dataManager.getDeviceNamesWithWifi();
			if (filter.isWifi()) {
				filteredSet.retainAll(devsWithWifi);
			} else {
				filteredSet.removeAll(devsWithWifi);
			}
		}
		
		if (filter.getDisplaySize() > 0) {
			filteredSet.retainAll(dataManager.getDeviceNamesWithDisplayGreaterThan(filter.getDisplaySize()));
		}
		
		if (!filter.getOs().equals("Qualsevol") && !filter.getOs().equals("Altres") ) {
			filteredSet.retainAll(dataManager.getDeviceNamesWithOS(filter.getOs()));
		} else if (filter.getOs().equals("Altres") ) {
			filteredSet.retainAll(dataManager.getDeviceNamesWithOSNoAndroidWindows());
		}
		
		Iterator<String> it = filteredSet.iterator();
		int i=1;
		while ( it.hasNext() ) {
			deviceItems.add(new SelectItem(Integer.toString(i), it.next()));
			i++;
		}
		filterON=true;
		return "success";
	}
	
	public String removeFilter() {
		deviceItems.clear();		
		Iterator<String> it = dataManager.getDeviceNames().iterator();
		int i=1;
		while ( it.hasNext() ) {
			deviceItems.add(new SelectItem(Integer.toString(i), it.next()));
			i++;
		}
		
		
		filterON = false;
		return "success";
	}
	
	public String query() {
		if (!selectedDevice.equals("0") ) {
			device = dataManager.getDeviceByModel(deviceItems.get(Integer.parseInt(selectedDevice)).getLabel());
			Set<File> files = dataManager.getFilesSupportedByModel(device.getModel());
			audioFiles.clear();
			imageFiles.clear();
			videoFiles.clear();
			executableFiles.clear();
			otherFiles.clear();
			
			Iterator<File> it = files.iterator();
			while (it.hasNext()) {
				File f = it.next();
				if (f.getClass().getName().equals("pfc.AudioFile") ) {
					audioFiles.add((AudioFile) f);
				} else if (f.getClass().getName().equals("pfc.ImageFile") ) {
					imageFiles.add((ImageFile) f);
				} else if (f.getClass().getName().equals("pfc.VideoFile") ) {
					videoFiles.add((VideoFile) f);
				} else if (f.getClass().getName().equals("pfc.ExecutableFile" )) {
					executableFiles.add((ExecutableFile) f);
				} else {
					otherFiles.add(f);
				}
			}
			showResults = true;
			return "success";
		} else {
			showResults = false;
			return "fail";
		}
			
	}

	
}
